<%
/* *
 功能：支付宝页面跳转同步通知页面
 版本：3.2
 日期：2011-03-17
 说明：
 以下代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写,并非一定要使用该代码。
 该代码仅供学习和研究支付宝接口使用，只是提供一个参考。

 //***********页面功能说明***********
 该页面可在本机电脑测试
 可放入HTML等美化页面的代码、商户业务逻辑程序代码
 TRADE_FINISHED(表示交易已经成功结束，并不能再对该交易做后续操作);
 TRADE_SUCCESS(表示交易已经成功结束，可以对该交易做后续操作，如：分润、退款等);
 //********************************
 * */
%>
<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*"%>
<%@ page import="java.util.Map"%>
<%@ page import="com.alipay.util.*"%>
<%@ page import="com.alipay.config.*"%>
<%@include file="/inc/init.jsp" %>
<html>
  <head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<%
	//获取支付宝GET过来反馈信息
	Map<String,String> params = new HashMap<String,String>();
	Map requestParams = request.getParameterMap();
	for (Iterator iter = requestParams.keySet().iterator(); iter.hasNext();) {
		String name = (String) iter.next();
		String[] values = (String[]) requestParams.get(name);
		String valueStr = "";
		for (int i = 0; i < values.length; i++) {
			valueStr = (i == values.length - 1) ? valueStr + values[i]
					: valueStr + values[i] + ",";
		}
		//乱码解决，这段代码在出现乱码时使用。如果mysign和sign不相等也可以使用这段代码转化
		valueStr = new String(valueStr.getBytes("ISO-8859-1"), "UTF-8");
		params.put(name, valueStr);
	}
	
	//获取支付宝的通知返回参数，可参考技术文档中页面跳转同步通知参数列表(以下仅供参考)//
	//商户订单号

	String out_trade_no = new String(request.getParameter("out_trade_no").getBytes("ISO-8859-1"),"UTF-8");

	//支付宝交易号

	String trade_no = new String(request.getParameter("trade_no").getBytes("ISO-8859-1"),"UTF-8");

	//交易状态
	String trade_status = new String(request.getParameter("trade_status").getBytes("ISO-8859-1"),"UTF-8");

	//获取支付宝的通知返回参数，可参考技术文档中页面跳转同步通知参数列表(以上仅供参考)//
	
	//计算得出通知验证结果
	boolean verify_result = AlipayNotify.verify(params);
	
	if(verify_result||(trade_status!=null&&trade_status.equals("TRADE_SUCCESS"))){//验证成功
		//////////////////////////////////////////////////////////////////////////////////////////
		//请在这里加上商户的业务逻辑程序代码

		//——请根据您的业务逻辑来编写程序（以下代码仅作参考）——
		if(trade_status.equals("TRADE_FINISHED") || trade_status.equals("TRADE_SUCCESS")){
			//判断该笔订单是否在商户网站中已经做过处理
				//如果没有做过处理，根据订单号（out_trade_no）在商户网站的订单系统中查到该笔订单的详细，并执行商户的业务程序
				//如果有做过处理，不执行商户的业务程序
		}
		
		//该页面可做页面美工编辑
		out.println("<p style='height:40px;line-height:40px;font-size:12px;color:#BD0000;'>恭喜您！在线支付成功！</p><br />");
		Order_list_db oldb=new Order_list_db();
		int orderid=IntUtil.s2i(out_trade_no);
		DOC doc=oldb.getOne(orderid);
		oldb.update(orderid,"admin_remark",doc.get("admin_remark")+"  支付宝已付款成功！");
		oldb.update(orderid,"state","20");//更新订单状态
		SmsUtil.sendAfterpay(orderid);//发送短信
		//——请根据您的业务逻辑来编写程序（以上代码仅作参考）——

		//////////////////////////////////////////////////////////////////////////////////////////
	}else{
		//该页面可做页面美工编辑
		out.println(" ");
	}
%>
<title>支付宝即时到账接口</title>
	<style type="text/css">
	    body{font:12px "宋体",Arial,Verdana;color:#000;text-align:center;}
	    td{padding:8px 15px;}
	    td.tdl{text-align:right;background-color:#F7F7F7;}
    </style>
	</head>
    <body>	
        <table width="450" border="1" bordercolordark="#FFFFFF" bordercolorlight="#CCCCCC" cellspacing="0" align="center">
            <tr>
                <td colspan="2" align="center">通知返回</td>
            </tr>
            <tr>
                <td width="35%" class="tdl">支付宝交易号：</td>
                <td width="65%"><%=pu.getString("trade_no")%></td>
            </tr>
            <tr>
                <td class="tdl">订单号：</td>
                <td><%=pu.getString("out_trade_no")%></td>
            </tr>
            <tr>
                <td class="tdl">付款总金额：</td>
                <td><%=pu.getString("total_fee")%></td>
            </tr>
            <tr>
                <td class="tdl">商品标题：</td>
                <td><%=pu.getString("subject") %></td>
            </tr>
            <tr>
                <td class="tdl">商品描述：</td>
                <td><%=pu.getString("body")%></td>
            </tr>
            <tr>
                <td class="tdl">交易状态：</td>
                <td><%
				String jystate=pu.getString("trade_status");
				if(jystate.equals("WAIT_BUYER_PAY")){
					jystate="等待买家付款";
				}else if(jystate.equals("WAIT_SELLER_SEND_GOODS")){
					jystate="买家付款，等待买家发货";
				}else if(jystate.equals("WAIT_BUYER_CONFIRM_GOODS")){
					jystate="卖家付款，等待买家确认";
				}else if(jystate.equals("TRADE_FINISHED")){
					jystate="交易完成";
				}else if(jystate.equals("TRADE_SUCCESS")){
					jystate="交易成功";
				}
				out.print(jystate);
				%></td>
            </tr>
        </table>
  </body>
</html>